package org.domaindrivenarchitecture.provs.framework.ubuntu.secret.secretSources

import org.domaindrivenarchitecture.provs.framework.core.ProgressType
import org.domaindrivenarchitecture.provs.framework.core.Prov
import org.domaindrivenarchitecture.provs.framework.core.Secret
import org.domaindrivenarchitecture.provs.framework.ubuntu.secret.SecretSource


/**
 * Retrieve secret from a file
 */
class FileSecretSource(fqFileName: String) : SecretSource(fqFileName) {

    override fun secret(): Secret {
        val p = Prov.newInstance(name = "FileSecretSource", progressType = ProgressType.NONE)
        return p.getSecret("cat " + input) ?: throw Exception("Failed to get secret.")
    }

    override fun secretNullable(): Secret? {
        val p = Prov.newInstance(name = "FileSecretSource", progressType = ProgressType.NONE)
        return p.getSecret("cat " + input)
    }
}